// Copyright (C) 2003-2009 by Object Mentor, Inc. All rights reserved.
// Released under the terms of the CPL Common Public License version 1.0.
package fitnesse.responders;

import fitnesse.FitNesseContext;
import fitnesse.html.HtmlUtil;
import fitnesse.http.Request;
import fitnesse.http.Response;
import fitnesse.responders.templateUtilities.HtmlPage;

public class DefaultResponder extends BasicResponder {
  public Response makeResponse(FitNesseContext context, Request request) {
    String content = prepareResponseDocument(context).html();
    return responseWith(content);
  }

  private HtmlPage prepareResponseDocument(FitNesseContext context) {
    HtmlPage responseDocument = context.pageFactory.newPage();
    HtmlUtil.addTitles(responseDocument, "Default Responder");
    responseDocument.setMainTemplate("defaultPage.vm");
    return responseDocument;
  }
}
