// Copyright (C) 2003-2009 by Object Mentor, Inc. All rights reserved.
// Released under the terms of the CPL Common Public License version 1.0.
package fitnesse.testsystems.slim;

import fitnesse.testsystems.ExecutionResult;
import fitnesse.testsystems.TestSummary;
import fitnesse.testsystems.slim.tables.ScenarioTable;

import java.util.Collection;

public interface SlimTestContext {
  String getSymbol(String symbolName);

  void setSymbol(String symbolName, String value);

  void addScenario(String scenarioName, ScenarioTable scenarioTable);

  ScenarioTable getScenario(String scenarioName);

  Collection<ScenarioTable> getScenarios();

  void incrementPassedTestsCount();

  void incrementFailedTestsCount();

  void incrementErroredTestsCount();

  void incrementIgnoredTestsCount();

  void increment(ExecutionResult testSummary);

  void increment(TestSummary testSummary);
}
